Loading...
Searching...
No Matches
ClpConstraintQuadratic Class Reference

Quadratic Constraint Class. More...

`#include <ClpConstraintQuadratic.hpp>`

Inheritance diagram for ClpConstraintQuadratic:
[legend]
Collaboration diagram for ClpConstraintQuadratic:
[legend]

## Public Member Functions

Stuff
virtual int | gradient (const ClpSimplex *model, const double *solution, double *gradient, double &functionValue, double &offset, bool useScaling=false, bool refresh=true) const
| Fills gradient.
virtual void | resize (int newNumberColumns)
| Resize constraint.
virtual void | deleteSome (int numberToDelete, const int *which)
| Delete columns in constraint.
virtual void | reallyScale (const double *columnScale)
| Scale constraint.
virtual int | markNonlinear (char *which) const
| Given a zeroed array sets nonquadratic columns to 1.
virtual int | markNonzero (char *which) const
| Given a zeroed array sets possible nonzero coefficients to 1.
Constructors and destructors
| ClpConstraintQuadratic ()
| Default Constructor.
| ClpConstraintQuadratic (int row, int numberQuadraticColumns, int numberColumns, const CoinBigIndex *start, const int *column, const double *element)
| Constructor from quadratic.
| ClpConstraintQuadratic (const ClpConstraintQuadratic &rhs)
| Copy constructor .
ClpConstraintQuadratic & | operator= (const ClpConstraintQuadratic &rhs)
| Assignment operator.
virtual | ~ClpConstraintQuadratic ()
| Destructor.
virtual ClpConstraint * | clone () const
| Clone.
Gets and sets
virtual int | numberCoefficients () const
| Number of coefficients.
int | numberColumns () const
| Number of columns in constraint.
CoinBigIndex * | start () const
| Column starts.
const int * | column () const
| Columns.
const double * | coefficient () const
| Coefficients.
Public Member Functions inherited from ClpConstraint
virtual double | functionValue (const ClpSimplex *model, const double *solution, bool useScaling=false, bool refresh=true) const
| Constraint function value.
| ClpConstraint ()
| Default Constructor.
| ClpConstraint (const ClpConstraint &)
| Copy constructor.
ClpConstraint & | operator= (const ClpConstraint &rhs)
| Assignment operator.
virtual | ~ClpConstraint ()
| Destructor.
int | type ()
| Returns type, 0 linear, 1 nonlinear.
int | rowNumber () const
| Row number (-1 is objective).
double | functionValue () const
| Stored constraint function value.
double | offset () const
| Constraint offset.
virtual void | newXValues ()
| Say we have new primal solution - so may need to recompute.

## Private Attributes

Private member data
Column starts
CoinBigIndex * | start_
int * | column_
| Column (if -1 then linear coefficient).
double * | coefficient_
| Coefficients.
int | numberColumns_
| Useful to have number of columns about.
int | numberCoefficients_
| Number of coefficients in gradient.
int | numberQuadraticColumns_
| Number of quadratic columns.

## Additional Inherited Members

Protected Attributes inherited from ClpConstraint
double * | lastGradient_
| Gradient at last evaluation.
double | functionValue_
| Value of non-linear part of constraint.
double | offset_
| Value of offset for constraint.
int | type_
| Type of constraint - linear is 1.
int | rowNumber_
| Row number (-1 is objective).

## Detailed Description

Quadratic Constraint Class.

Definition at line 17 of file ClpConstraintQuadratic.hpp.

## Constructor & Destructor Documentation

## ClpConstraintQuadratic() [1/3]

ClpConstraintQuadratic::ClpConstraintQuadratic | ( |  | ) |

Default Constructor.

## ClpConstraintQuadratic() [2/3]

ClpConstraintQuadratic::ClpConstraintQuadratic | ( | int | row,
|  | int | numberQuadraticColumns,
|  | int | numberColumns,
|  | const CoinBigIndex * | start,
|  | const int * | column,
|  | const double * | element )

Constructor from quadratic.

## ClpConstraintQuadratic() [3/3]

ClpConstraintQuadratic::ClpConstraintQuadratic | ( | const ClpConstraintQuadratic & | rhs | ) |

Copy constructor .

## ~ClpConstraintQuadratic()

virtual ClpConstraintQuadratic::~ClpConstraintQuadratic | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## gradient()

virtual int ClpConstraintQuadratic::gradient | ( | const ClpSimplex * | model,
|  | const double * | solution,
|  | double * | gradient,
|  | double & | functionValue,
|  | double & | offset,
|  | bool | useScaling = false,
|  | bool | refresh = true ) const

virtual

Fills gradient.

If Quadratic then solution may be NULL, also returns true value of function and offset so we can use x not deltaX in constraint If refresh is false then uses last solution Uses model for scaling Returns non-zero if gradient udefined at current solution

Implements ClpConstraint.

## resize()

virtual void ClpConstraintQuadratic::resize | ( | int | newNumberColumns | ) |

virtual

Resize constraint.

Implements ClpConstraint.

## deleteSome()

virtual void ClpConstraintQuadratic::deleteSome | ( | int | numberToDelete,
|  | const int * | which )

virtual

Delete columns in constraint.

Implements ClpConstraint.

## reallyScale()

virtual void ClpConstraintQuadratic::reallyScale | ( | const double * | columnScale | ) |

virtual

Scale constraint.

Implements ClpConstraint.

## markNonlinear()

virtual int ClpConstraintQuadratic::markNonlinear | ( | char * | which | ) | const

virtual

Given a zeroed array sets nonquadratic columns to 1.

Returns number of nonquadratic columns

Implements ClpConstraint.

## markNonzero()

virtual int ClpConstraintQuadratic::markNonzero | ( | char * | which | ) | const

virtual

Given a zeroed array sets possible nonzero coefficients to 1.

Returns number of nonzeros

Implements ClpConstraint.

## operator=()

ClpConstraintQuadratic & ClpConstraintQuadratic::operator= | ( | const ClpConstraintQuadratic & | rhs | ) |

Assignment operator.

## clone()

virtual ClpConstraint * ClpConstraintQuadratic::clone | ( |  | ) | const

virtual

Clone.

Implements ClpConstraint.

## numberCoefficients()

virtual int ClpConstraintQuadratic::numberCoefficients | ( |  | ) | const

virtual

Number of coefficients.

Implements ClpConstraint.

## numberColumns()

int ClpConstraintQuadratic::numberColumns | ( |  | ) | const

inline

Number of columns in constraint.

Definition at line 80 of file ClpConstraintQuadratic.hpp.

## start()

CoinBigIndex * ClpConstraintQuadratic::start | ( |  | ) | const

inline

Column starts.

Definition at line 85 of file ClpConstraintQuadratic.hpp.

## column()

const int * ClpConstraintQuadratic::column | ( |  | ) | const

inline

Columns.

Definition at line 90 of file ClpConstraintQuadratic.hpp.

## coefficient()

const double * ClpConstraintQuadratic::coefficient | ( |  | ) | const

inline

Coefficients.

Definition at line 95 of file ClpConstraintQuadratic.hpp.

## Member Data Documentation

## start_

CoinBigIndex* ClpConstraintQuadratic::start_

private

Definition at line 106 of file ClpConstraintQuadratic.hpp.

## column_

int* ClpConstraintQuadratic::column_

private

Column (if -1 then linear coefficient).

Definition at line 108 of file ClpConstraintQuadratic.hpp.

## coefficient_

double* ClpConstraintQuadratic::coefficient_

private

Coefficients.

Definition at line 110 of file ClpConstraintQuadratic.hpp.

## numberColumns_

int ClpConstraintQuadratic::numberColumns_

private

Useful to have number of columns about.

Definition at line 112 of file ClpConstraintQuadratic.hpp.

## numberCoefficients_

int ClpConstraintQuadratic::numberCoefficients_

private

Number of coefficients in gradient.

Definition at line 114 of file ClpConstraintQuadratic.hpp.

## numberQuadraticColumns_

int ClpConstraintQuadratic::numberQuadraticColumns_

private

Number of quadratic columns.

Definition at line 116 of file ClpConstraintQuadratic.hpp.

The documentation for this class was generated from the following file:

- Clp/src/ClpConstraintQuadratic.hpp